<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: SockServ Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classSockServ-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">SockServ Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Provide a socket listener and the ability to send data to connected partners.  
 <a href="classSockServ.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="SockServ_8h_source.html">SockServ.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a8c3fa6bf7bb34ebf9b8db86048ded61c"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#a8c3fa6bf7bb34ebf9b8db86048ded61c">SockServ</a> (uint16_t port)</td></tr>
<tr class="memdesc:a8c3fa6bf7bb34ebf9b8db86048ded61c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create an instance of the class.  <a href="#a8c3fa6bf7bb34ebf9b8db86048ded61c">More...</a><br /></td></tr>
<tr class="separator:a8c3fa6bf7bb34ebf9b8db86048ded61c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9fb32006f0a3a89da0145971a17ccab4"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#a9fb32006f0a3a89da0145971a17ccab4">SockServ</a> ()</td></tr>
<tr class="separator:a9fb32006f0a3a89da0145971a17ccab4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a18b87a413bac01b49e89f7d616a14da8"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#a18b87a413bac01b49e89f7d616a14da8">~SockServ</a> ()</td></tr>
<tr class="separator:a18b87a413bac01b49e89f7d616a14da8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74fdc3b3fcb84a1e64505b1c792032f9"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#a74fdc3b3fcb84a1e64505b1c792032f9">connectedCount</a> ()</td></tr>
<tr class="memdesc:a74fdc3b3fcb84a1e64505b1c792032f9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Determine the number of connected partners.  <a href="#a74fdc3b3fcb84a1e64505b1c792032f9">More...</a><br /></td></tr>
<tr class="separator:a74fdc3b3fcb84a1e64505b1c792032f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a28ad7ac11058be8dbb87439c430329c2"><td class="memItemLeft" align="right" valign="top"><a id="a28ad7ac11058be8dbb87439c430329c2"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#a28ad7ac11058be8dbb87439c430329c2">disconnect</a> (<a class="el" href="classSocket.html">Socket</a> s)</td></tr>
<tr class="memdesc:a28ad7ac11058be8dbb87439c430329c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Disconnect any connected partners. <br /></td></tr>
<tr class="separator:a28ad7ac11058be8dbb87439c430329c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa62641e571ccec4dd6ec8c141204fe5e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#aa62641e571ccec4dd6ec8c141204fe5e">getSSL</a> ()</td></tr>
<tr class="separator:aa62641e571ccec4dd6ec8c141204fe5e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9e4e21eb4e94912fd403a7e3dcbdb54c"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#a9e4e21eb4e94912fd403a7e3dcbdb54c">receiveData</a> (<a class="el" href="classSocket.html">Socket</a> s, void *pData, size_t maxData)</td></tr>
<tr class="memdesc:a9e4e21eb4e94912fd403a7e3dcbdb54c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait for data.  <a href="#a9e4e21eb4e94912fd403a7e3dcbdb54c">More...</a><br /></td></tr>
<tr class="separator:a9e4e21eb4e94912fd403a7e3dcbdb54c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3e4e4cc30becc9440573c3285e8004d2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#a3e4e4cc30becc9440573c3285e8004d2">sendData</a> (uint8_t *data, size_t length)</td></tr>
<tr class="memdesc:a3e4e4cc30becc9440573c3285e8004d2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send data to any connected partners.  <a href="#a3e4e4cc30becc9440573c3285e8004d2">More...</a><br /></td></tr>
<tr class="separator:a3e4e4cc30becc9440573c3285e8004d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac50c88830b1b4a3e75b8fbd82799b08d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#ac50c88830b1b4a3e75b8fbd82799b08d">sendData</a> (std::string str)</td></tr>
<tr class="memdesc:ac50c88830b1b4a3e75b8fbd82799b08d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send data from a string to any connected partners.  <a href="#ac50c88830b1b4a3e75b8fbd82799b08d">More...</a><br /></td></tr>
<tr class="separator:ac50c88830b1b4a3e75b8fbd82799b08d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a12c8f4baa1bad7d405a39c4ad3310e37"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#a12c8f4baa1bad7d405a39c4ad3310e37">setPort</a> (uint16_t port)</td></tr>
<tr class="memdesc:a12c8f4baa1bad7d405a39c4ad3310e37"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the port number to use.  <a href="#a12c8f4baa1bad7d405a39c4ad3310e37">More...</a><br /></td></tr>
<tr class="separator:a12c8f4baa1bad7d405a39c4ad3310e37"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a26b1666ac84ee10fc3a39086192e3617"><td class="memItemLeft" align="right" valign="top"><a id="a26b1666ac84ee10fc3a39086192e3617"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>setSSL</b> (bool use=true)</td></tr>
<tr class="separator:a26b1666ac84ee10fc3a39086192e3617"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abbfb5d8eba2ef0a47fa0aa981a43f6dc"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#abbfb5d8eba2ef0a47fa0aa981a43f6dc">start</a> ()</td></tr>
<tr class="memdesc:abbfb5d8eba2ef0a47fa0aa981a43f6dc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Start listening for new partner connections.  <a href="#abbfb5d8eba2ef0a47fa0aa981a43f6dc">More...</a><br /></td></tr>
<tr class="separator:abbfb5d8eba2ef0a47fa0aa981a43f6dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4d6d90089cd108ba10e481e4aca274f4"><td class="memItemLeft" align="right" valign="top"><a id="a4d6d90089cd108ba10e481e4aca274f4"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#a4d6d90089cd108ba10e481e4aca274f4">stop</a> ()</td></tr>
<tr class="memdesc:a4d6d90089cd108ba10e481e4aca274f4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Stop listening for new partner connections. <br /></td></tr>
<tr class="separator:a4d6d90089cd108ba10e481e4aca274f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe1a76ac356518aac617b25f6c6b3c42"><td class="memItemLeft" align="right" valign="top"><a id="afe1a76ac356518aac617b25f6c6b3c42"></a>
<a class="el" href="classSocket.html">Socket</a>&#160;</td><td class="memItemRight" valign="bottom"><b>waitForData</b> (std::set&lt; <a class="el" href="classSocket.html">Socket</a> &gt; &amp;socketSet)</td></tr>
<tr class="separator:afe1a76ac356518aac617b25f6c6b3c42"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad0dfa6f354891c6f8b435d831fea14f5"><td class="memItemLeft" align="right" valign="top"><a id="ad0dfa6f354891c6f8b435d831fea14f5"></a>
<a class="el" href="classSocket.html">Socket</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSockServ.html#ad0dfa6f354891c6f8b435d831fea14f5">waitForNewClient</a> ()</td></tr>
<tr class="memdesc:ad0dfa6f354891c6f8b435d831fea14f5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait for a client connection to be present. Returns when a client connection is present. This can block until a client connects or can return immediately is there is already a client connection in existence. <br /></td></tr>
<tr class="separator:ad0dfa6f354891c6f8b435d831fea14f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Provide a socket listener and the ability to send data to connected partners. </p>
<p>We use this class to listen on a given socket and accept connections from partners. When we call one of the <a class="el" href="classSockServ.html#a3e4e4cc30becc9440573c3285e8004d2" title="Send data to any connected partners.">sendData()</a> methods, the data passed as parameters is then sent to the connected partners.</p>
<p>Here is an example code fragment that uses the class:</p>
<div class="fragment"><div class="line"><a class="code" href="classSockServ.html">SockServ</a> mySockServer = <a class="code" href="classSockServ.html#a9fb32006f0a3a89da0145971a17ccab4">SockServ</a>(9876);</div><div class="line">mySockServer.<a class="code" href="classSockServ.html#abbfb5d8eba2ef0a47fa0aa981a43f6dc">start</a>();</div><div class="line"></div><div class="line"><span class="comment">// Later ...</span></div><div class="line">mySockServer.<a class="code" href="classSockServ.html#a3e4e4cc30becc9440573c3285e8004d2">sendData</a>(data, dataLen);</div></div><!-- fragment --> </div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a8c3fa6bf7bb34ebf9b8db86048ded61c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8c3fa6bf7bb34ebf9b8db86048ded61c">&#9670;&nbsp;</a></span>SockServ() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">SockServ::SockServ </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>port</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Create an instance of the class. </p>
<p>We won't actually start listening for clients until after the <a class="el" href="classSockServ.html#abbfb5d8eba2ef0a47fa0aa981a43f6dc" title="Start listening for new partner connections.">start()</a> method has been called. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">port</td><td>The TCP/IP port number on which we will listen for incoming connection requests. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a9fb32006f0a3a89da0145971a17ccab4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9fb32006f0a3a89da0145971a17ccab4">&#9670;&nbsp;</a></span>SockServ() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">SockServ::SockServ </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Constructor </p>

</div>
</div>
<a id="a18b87a413bac01b49e89f7d616a14da8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a18b87a413bac01b49e89f7d616a14da8">&#9670;&nbsp;</a></span>~SockServ()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">SockServ::~SockServ </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Destructor </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a74fdc3b3fcb84a1e64505b1c792032f9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a74fdc3b3fcb84a1e64505b1c792032f9">&#9670;&nbsp;</a></span>connectedCount()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int SockServ::connectedCount </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Determine the number of connected partners. </p>
<dl class="section return"><dt>Returns</dt><dd>The number of connected partners. </dd></dl>

</div>
</div>
<a id="aa62641e571ccec4dd6ec8c141204fe5e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa62641e571ccec4dd6ec8c141204fe5e">&#9670;&nbsp;</a></span>getSSL()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool SockServ::getSSL </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Get the SSL status. </p>

</div>
</div>
<a id="a9e4e21eb4e94912fd403a7e3dcbdb54c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9e4e21eb4e94912fd403a7e3dcbdb54c">&#9670;&nbsp;</a></span>receiveData()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t SockServ::receiveData </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classSocket.html">Socket</a>&#160;</td>
          <td class="paramname"><em>s</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>pData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>maxData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Wait for data. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pData</td><td>Pointer to buffer to hold the data. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">maxData</td><td>Maximum size of the data to receive. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The amount of data returned or 0 if there was an error. </dd></dl>

</div>
</div>
<a id="a3e4e4cc30becc9440573c3285e8004d2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3e4e4cc30becc9440573c3285e8004d2">&#9670;&nbsp;</a></span>sendData() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void SockServ::sendData </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>length</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send data to any connected partners. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>A sequence of bytes to send to the partner. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">length</td><td>The length of the sequence of bytes to send to the partner. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ac50c88830b1b4a3e75b8fbd82799b08d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac50c88830b1b4a3e75b8fbd82799b08d">&#9670;&nbsp;</a></span>sendData() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void SockServ::sendData </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send data from a string to any connected partners. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">str</td><td>A string from which sequence of bytes will be used to send to the partner. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a12c8f4baa1bad7d405a39c4ad3310e37"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a12c8f4baa1bad7d405a39c4ad3310e37">&#9670;&nbsp;</a></span>setPort()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void SockServ::setPort </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>port</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the port number to use. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">port</td><td>The port number to use. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="abbfb5d8eba2ef0a47fa0aa981a43f6dc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abbfb5d8eba2ef0a47fa0aa981a43f6dc">&#9670;&nbsp;</a></span>start()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void SockServ::start </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Start listening for new partner connections. </p>
<p>The port number on which we will listen is the one defined when the class was created. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="SockServ_8h_source.html">SockServ.h</a></li>
<li>SockServ.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
